
require 'quickbase_client'

def downloadFiles1(username,password,cwd,realm)
  qbc = QuickBase::Client.init({"username"=>username,"password"=>password,"org"=>realm})
  #qbc.printRequestsAndResponses=true
  dbid = qbc.findDBByName(cwd)
  qbc.getSchema(dbid)
  dbid = qbc.lookupChdbid(cwd.dup)
  downloadFiles3(qbc,username,password,dbid,"File Attachment")
end

def downloadFiles2(username,password,dbid,fieldName,realm,qid)
  qbc = QuickBase::Client.init({"username"=>username,"password"=>password,"org"=>realm})
  #qbc.printRequestsAndResponses=true
  qbc.getSchema(dbid)
  downloadFiles3(qbc,username,password,dbid,fieldName,realm,qid)
end

def downloadFiles3(qbc,username,password,dbid,fieldName,realm,qid)

   fieldNames = qbc.getFieldNames(dbid)
   clist = ""
   fid = ""
   fieldNames.each{|f|
      id = qbc.lookupFieldIDByName(f)
      fid = id.dup if f == fieldName
      clist << id
      clist << "."
   }
   clist[-1,1]=""

   if fid == ""
     fid = fieldName.dup
     fieldName = qbc.lookupFieldNameFromID(fid)
   end

   qbc.iterateRecords(dbid,fieldNames,nil,qid,nil,clist,"3"){|r|
      if r and r[fieldName] and r[fieldName].length > 0 
         next if r[fieldName].include?("https:") or r[fieldName].include?("http:")
         puts "Downloading #{r[fieldName]}"
         qbc.downLoadFile(dbid,r["Record ID#"],fid)
         if qbc.fileContents
            filename = "#{r["Record ID#"]}_#{r[fieldName]}"
            File.open( filename, "wb" ){|f|
               f.write(qbc.fileContents)
            }
         end   
      end
   }
  puts "\nFinished downloading files in QuickBase Record ID# order."
  puts "(Later copies of files overwrite previous copies)."
  puts "\nYou can repeat this download using downloadFilesToFolder.exe #{username} #{password} #{dbid} #{fid} #{realm} #{qid}."
end

def getInputAndRun
   mycwd = Dir.pwd.gsub('/','\\')

   if ARGV[5]
     downloadFiles2(ARGV[0],ARGV[1],ARGV[2],ARGV[3],ARGV[4],ARGV[5])
   else
   
     print "\nPlease enter your QuickBase username: "
     username = gets.chomp
     print "\nPlease enter your QuickBase password: "
     password = gets.chomp
     print "\nPlease enter your QuickBase realm (default is www): "
     realm = gets.chomp
     realm = "www" unless realm and realm.length > 0
     print "\nEnter 'y' to download the files from a '#{mycwd}' QuickBase application: "
     y = gets.chomp
     
     if y == "y" or y == "Y"
       downloadFiles1(username,password,mycwd,realm)
     else
       print "\nPlease enter the id of your QuickBase table: "
       dbid = gets.chomp
       print "\nPlease enter the name or id of the QuickBase File Attachment field in your table. (e.g. File): "
       fieldName = gets.chomp
       print "\nPlease enter the id of a QuickBase Report to use from your table. (default is 1): "
       qid = gets.chomp
       qid = "1" unless qid and qid.length > 0
       downloadFiles2(username,password,dbid,fieldName,realm,qid)
     end
   end

end

getInputAndRun
